package mn.grapecity.fluttercomponent.fluttermmcomponent_example;

import android.os.Bundle;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Observable;
import java.util.Observer;

import io.flutter.embedding.android.FlutterActivity;
import mn.grapecity.fluttercomponent.fluttermmcomponent.FluttermmcomponentPlugin;
import mn.mostmoney.android.login.MMLoginHelper;
import mn.mostmoney.android.login.SharedInstance;

public class MainActivity extends FlutterActivity implements Observer {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        SharedInstance.instance.addObserver(MainActivity.this);
        Log.d("createshdee:", "createshdee");
    }

//    @Override
//    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
//        if (requestCode == MMLoginHelper.RESULT_CODE_SUCCESS) {
//            String code = data.getStringExtra("code");
//            String description = data.getStringExtra("description");
//            String rrn = data.getStringExtra("rrn");
//
//            FluttermmcomponentPlugin.hasResponse("onSuccess", "result.toString()");
//        }
//    }

    @Override
    public void update(Observable obs, Object obj) {
        JSONObject data = SharedInstance.instance.getState();
        int status = SharedInstance.instance.getStatus();

        Log.d("data:", " " + data);
        Log.d("status:", " " + status);

        if (status == MMLoginHelper.RESULT_CODE_SUCCESS) {
            SharedInstance.instance.deleteObservers();
            try {
                if (data.has("biometric")) {
                    FluttermmcomponentPlugin.setBiometric(data.getBoolean("biometric"));
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            JSONObject result = new JSONObject();
            try {
                result.put("data", data);
            } catch (JSONException e) {
                e.printStackTrace();
            }

            FluttermmcomponentPlugin.hasResponse("onSuccess", result.toString());

        } else if (status == MMLoginHelper.RESULT_CODE_FAILED) {
            try {
                if (data.has("biometric")) {
                    FluttermmcomponentPlugin.setBiometric(data.getBoolean("biometric"));
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            JSONObject result = new JSONObject();
            try {
                result.put("data", data);
            } catch (JSONException e) {
                e.printStackTrace();
            }

            FluttermmcomponentPlugin.hasResponse("onFail", result.toString());
        } else if (status == MMLoginHelper.RESULT_CODE_GOTO) {

            SharedInstance.instance.deleteObservers();

            JSONObject result = new JSONObject();
            try {
                result.put("data", data);
            } catch (JSONException e) {
                e.printStackTrace();
            }

            FluttermmcomponentPlugin.hasResponse("onGoto", result.toString());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
